#include "alice.h"

int main(int argc, char** argv){

  char *alans;

  char *input = NULL;
  char *username = NULL;
  char *initfile = NULL;
  char *varname[25];
  char *varval[25];

  int i, j = 0;
  int overide_url = 0;

  if(argc < 2){
    printf("Command_alice written by Anthony Taylor\nUsage: command_alice [-o] [-u username] [-i initfile] [-s name value] input_dialog\n-o  Override HTML stripping\n-u username : Save variables to this file. (defaults to localhost.txt)\n-i initfile : Use

 this init file. (defaults to alice.ini)\n-s name value : The Variable name equal to value.\n");
    return (1);
  }
  for (i = 1; i < argc; i++){
    if (!(strcmp(argv[i],"-i"))){
      initfile = argv[++i];
    }

    else if (!(strcmp(argv[i],"-u"))){
      username = argv[++i];
    }
    else if (!(strcmp(argv[i],"-o"))){
      overide_url = 1;
    }
    else if (!(strcmp(argv[i],"-s"))){
      varname[j] = argv[++i];
      varval[j++] = argv[++i];
    }
    else {
      input = argv[i];
    }
  }
  if (initfile == NULL) {
    if (initialize("data/alice.ini")) return(1);
  }
  else if (initialize(initfile)) return(1);
  if (username == NULL) loadvars("log/localuser.txt");
  else loadvars(username);
  for (i=0; i < j; i++) {
    setvar(1,varname[i],varval[i]);
  }
  alans = respond( input );
  if (!(overide_url)) stripurl(alans);
  printf( "%s",alans );
  if (username == NULL) savevars("log/localuser.txt");
  else savevars( username );
  deinitialize();
  return(0);
}  
