#include <app/Application.h>

#include "ShareWindow.h"

#include "alice.h"

int main(int, char **)
{
   if (initialize("data/alice.ini"))
   {
      printf("Couldn't initialize ALICE!\n");
      return 10;
   }
   loadvars("log/localuser.txt");
   BApplication app("application/x-vnd.Sugoi-BeShare");
   ShareWindow * win = new ShareWindow();
   win->Show();
   app.Run();
   savevars("log/localuser.txt");
   deinitialize();
   return 0;
}
